﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading;
using System.Net;
using System.Net.Sockets;
using System.Windows.Forms;
using System.IO;
using System.Xml;

namespace QCW
{
    public class ETHCommPro
    {
        Thread threadUdpReceive;
        UInt32 UPDRecvFlag = 0;
        public UdpClient Sendudp;
        public IPEndPoint LocalHostIep;
        public static int IPProt = 8099;
        byte[] ReceiveBuf = new byte[2000];
        int RecLen = 0;
        string LaserIPAddress = null;

        public ETHCommPro()
        {
            string strpassword = null;
            XmlDocument xmlDoc = new XmlDocument();
            try
            {
                xmlDoc.Load("Config.xml");
            }
            catch (Exception ex)
            {
                XmlTextWriter writer = new XmlTextWriter("Config.xml", System.Text.Encoding.UTF8);
                //使用自动缩进便于阅读
                writer.Formatting = Formatting.Indented;
                //XML声明 
                writer.WriteStartDocument();
                //书写根元素 
                writer.WriteStartElement("Config");
                //开始一个元素 
                writer.WriteStartElement("item");
                //向先前创建的元素中添加一个属性
                writer.WriteAttributeString("id", "1");
                //添加子元素 
                writer.WriteElementString("SoftFunc", "1234");
                writer.WriteElementString("IP", "192.168.0.10");
                writer.WriteElementString("PASSWORD", "1234");
                //关闭item元素
                writer.WriteEndElement(); // 关闭元素
                writer.WriteEndElement(); // 关闭元素
                //在节点间添加一些空
                writer.WriteEndDocument();
                writer.Close();
                xmlDoc.Load("Config.xml");
            }
            XmlNodeList nodeList = xmlDoc.SelectSingleNode("Config").ChildNodes;//获取Config节点的所有子节点
            foreach (XmlNode xn in nodeList)//遍历所有子节点
            {
                XmlElement xe = (XmlElement)xn;//将子节点类型转换为XmlElement类型
                if (xe.GetAttribute("id") == "1")//如果id属性值为“1”
                {

                    XmlNodeList nls = xe.ChildNodes;//继续获取xe子节点的所有子节点
                    foreach (XmlNode xn1 in nls)//遍历
                    {
                        XmlElement xe2 = (XmlElement)xn1;//转换类型
                        if (xe2.Name == "IP")//如果找到
                        {
                            strpassword = xe2.InnerText;
                            LaserIPAddress = strpassword;
                        }
                    }
                    break;
                }
            }          
            
        }
        private ushort GetCRC(byte[] Array, int pianyi, int Len)
        {
            ushort CRCData = 0xFFFF;//set all 1;
            int IX, IY;

            if (Len <= 0) CRCData = 0;
            else
            {
                for (IX = pianyi; IX < Len + pianyi; IX++)
                {
                    CRCData = (ushort)(CRCData ^ (UInt16)(Array[IX]));
                    for (IY = 0; IY <= 7; IY++)
                        if ((CRCData & 1) != 0)
                            CRCData = (ushort)((CRCData >> 1) ^ 0xA001);
                        else
                            CRCData = (ushort)(CRCData >> 1);    //
                }

            }
            return (CRCData);
        }

        public int ETHCmdSendString(string Cmd, ref string recbuf)
        {
            try
            {
                if (LaserIPAddress == null) LaserIPAddress = "192.168.0.10";
                IPEndPoint udpSend = new IPEndPoint(IPAddress.Parse(LaserIPAddress), 8099);
                UPDRecvFlag = 0;
                threadUdpReceive.IsBackground = true;
                Sendudp.Send(Encoding.UTF7.GetBytes(Cmd), Cmd.Length, udpSend);
                for (int j = 0; j < 200; j++)
                {
                    Thread.Sleep(10);
                    if (UPDRecvFlag == 1) break;
                }
                if (UPDRecvFlag == 1)
                {
                    if (RecLen > 2 && RecLen < (ReceiveBuf.Length - 50))
                    {
                        recbuf = System.Text.Encoding.ASCII.GetString(ReceiveBuf,0,RecLen);

                        RecLen = recbuf.Length;
                        
                    }
                    return RecLen;
                }
            }
            catch (Exception ex)
            {

                //现实异常信息给客户。  
                MessageBox.Show(ex.Message);
                return -1;
            }

            return RecLen;
        }

        public int ETHCommSend(UInt16 id, byte Cmd, byte[] sendbuf, int SendLen, ref RSComStruct ttRSComStruct)
        {
            byte[] SendBuf = new byte[2000];
            int i = 0;
            SendBuf[i++] = 0xfe;
            SendBuf[i++] = 0xfe;
            SendBuf[i++] = 0xfe;
            SendBuf[i++] = 0x68;
            SendBuf[i++] = (byte)(id >> 8);
            SendBuf[i++] = (byte)id;
            SendBuf[i++] = Cmd;
            SendBuf[i++] = 0X00;
            SendBuf[i++] = (byte)(SendLen >> 8);
            SendBuf[i++] = (byte)SendLen;
            Array.Copy(sendbuf, 0, SendBuf, i, SendLen);
            i += SendLen;
            ushort crcdata = GetCRC(SendBuf, 4, i - 4);
            SendBuf[i++] = (byte)(crcdata >> 8);
            SendBuf[i++] = (byte)crcdata;
            SendBuf[i++] = 0x55;
            try
            {
                if (LaserIPAddress == null) LaserIPAddress = "192.168.0.10";
                IPEndPoint udpSend = new IPEndPoint(IPAddress.Parse(LaserIPAddress), 8099);
                string sendstring = UARTCommPro.byteToHexStr(SendBuf, i);
               
                UPDRecvFlag = 0;
                threadUdpReceive.IsBackground = true;
                Sendudp.Send(Encoding.UTF7.GetBytes(sendstring), sendstring.Length, udpSend);
                for (int j = 0; j < 500; j++)
                {
                    Thread.Sleep(10);
                    if (UPDRecvFlag == 1) break;
                }
                if (UPDRecvFlag == 1)
                {
                    if (RecLen > 2 && RecLen < (ReceiveBuf.Length - 50))
                    {
                        byte[] ReceiveBufTemp = new byte[RecLen - 1];
                        Array.Copy(ReceiveBuf, ReceiveBufTemp, RecLen - 1);
                        string str = System.Text.Encoding.ASCII.GetString(ReceiveBufTemp);

                        byte[] RecArray = UARTCommPro.ToBytes(str);
                        if (RecArray == null)
                        {
                            return -1;
                        }
                        if (RecArray.Length > 0)
                        {
                            Array.Copy(RecArray, ReceiveBuf, RecArray.Length);
                        }
                        else
                        {
                            return -1;
                        }
                        RecLen = RecArray.Length;
                        ushort crcvalue = GetCRC(ReceiveBuf, 4, RecLen - 7);
                        ushort crcvalue2 = (ushort)((ushort)(((ushort)ReceiveBuf[RecLen - 3]) << 8) + (ushort)ReceiveBuf[RecLen - 2]);
                        if (crcvalue == crcvalue2)
                        {
                            ttRSComStruct.ID = ReceiveBuf[4];
                            ttRSComStruct.ID <<= 8;
                            ttRSComStruct.ID += ReceiveBuf[5];
                            ttRSComStruct.CMD = ReceiveBuf[6];
                            ttRSComStruct.Para = ReceiveBuf[7];
                            ttRSComStruct.RecLength = ReceiveBuf[8];
                            ttRSComStruct.RecLength <<= 8;
                            ttRSComStruct.RecLength += ReceiveBuf[9];
                            Array.Copy(ReceiveBuf, 10, ttRSComStruct.RecDada, 0, ttRSComStruct.RecLength);
                        }
                        else
                        {
                            RecLen = 0;
                        }
                    }
                    return RecLen;
                }
            }
            catch (Exception ex)
            {

                //现实异常信息给客户。  
                MessageBox.Show(ex.Message);
                return -1;
            }
            return 0;
        }

        private void ReceiveUDP()
        {
            IPEndPoint iep = new IPEndPoint(IPAddress.Any, 8099);
            try
            {
                
                while (true)
                {
                    byte[] buff = Sendudp.Receive(ref iep);
                    RecLen = buff.Length;
                    Array.Copy(buff, ReceiveBuf, RecLen);
                    ReceiveBuf[RecLen] = 0;
                    UPDRecvFlag = 1;
                }
            }
            catch (SystemException ex)
            {
                //MessageBox.Show(ex.ToString());
            }
        }
        public void ETHOpen()
        {
            try
            {
                string strHostName = Dns.GetHostName();
                IPHostEntry ipEntry = Dns.GetHostEntry(strHostName);
                string LocalHostIp;
                if(ipEntry.AddressList[0].AddressFamily==AddressFamily.InterNetwork)
                {
                     LocalHostIp = ipEntry.AddressList[0].ToString();
                }
                else
                {
                     LocalHostIp = ipEntry.AddressList[1].ToString();
                }
                
                LocalHostIep = new IPEndPoint(IPAddress.Parse(LocalHostIp), IPProt);
                Sendudp = new UdpClient();
                threadUdpReceive = new Thread(new ThreadStart(ReceiveUDP));
                Sendudp.Client.Bind(LocalHostIep);
                threadUdpReceive.Start();
            }
            catch (Exception ex)
            {

                //现实异常信息给客户。  
                MessageBox.Show(ex.Message);
            }
            
            
        }

        public void ETHClose()
        {
            if(Sendudp!= null)Sendudp.Close();
            if (threadUdpReceive == null) return;
            if (threadUdpReceive.IsAlive == true)
            {
                threadUdpReceive.Abort();
            }
        }
    }

    
}
